Index: uspace/srv/hid/display/dsops.c
===================================================================
--- uspace/srv/hid/display/dsops.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/display/dsops.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -46,12 +46,18 @@
 static errno_t disp_window_create(void *, display_wnd_params_t *, sysarg_t *);
 static errno_t disp_window_destroy(void *, sysarg_t);
-static errno_t disp_window_move_req(void *, sysarg_t, gfx_coord2_t *);
+static errno_t disp_window_move_req(void *, sysarg_t, gfx_coord2_t *,
+    sysarg_t);
 static errno_t disp_window_move(void *, sysarg_t, gfx_coord2_t *);
 static errno_t disp_window_get_pos(void *, sysarg_t, gfx_coord2_t *);
+static errno_t disp_window_get_max_rect(void *, sysarg_t, gfx_rect_t *);
 static errno_t disp_window_resize_req(void *, sysarg_t,
-    display_wnd_rsztype_t, gfx_coord2_t *);
+    display_wnd_rsztype_t, gfx_coord2_t *, sysarg_t);
 static errno_t disp_window_resize(void *, sysarg_t, gfx_coord2_t *,
     gfx_rect_t *);
+static errno_t disp_window_minimize(void *, sysarg_t);
+static errno_t disp_window_maximize(void *, sysarg_t);
+static errno_t disp_window_unmaximize(void *, sysarg_t);
 static errno_t disp_window_set_cursor(void *, sysarg_t, display_stock_cursor_t);
+static errno_t disp_window_set_caption(void *, sysarg_t, const char *);
 static errno_t disp_get_event(void *, sysarg_t *, display_wnd_ev_t *);
 static errno_t disp_get_info(void *, display_info_t *);
@@ -63,7 +69,12 @@
 	.window_move = disp_window_move,
 	.window_get_pos = disp_window_get_pos,
+	.window_get_max_rect = disp_window_get_max_rect,
 	.window_resize_req = disp_window_resize_req,
 	.window_resize = disp_window_resize,
+	.window_minimize = disp_window_minimize,
+	.window_maximize = disp_window_maximize,
+	.window_unmaximize = disp_window_unmaximize,
 	.window_set_cursor = disp_window_set_cursor,
+	.window_set_caption = disp_window_set_caption,
 	.get_event = disp_get_event,
 	.get_info = disp_get_info
@@ -117,5 +128,5 @@
 
 static errno_t disp_window_move_req(void *arg, sysarg_t wnd_id,
-    gfx_coord2_t *pos)
+    gfx_coord2_t *pos, sysarg_t pos_id)
 {
 	ds_client_t *client = (ds_client_t *) arg;
@@ -131,5 +142,5 @@
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "disp_window_move_req()");
-	ds_window_move_req(wnd, pos);
+	ds_window_move_req(wnd, pos, pos_id);
 	ds_display_unlock(client->display);
 	return EOK;
@@ -175,6 +186,26 @@
 }
 
+static errno_t disp_window_get_max_rect(void *arg, sysarg_t wnd_id,
+    gfx_rect_t *rect)
+{
+	ds_client_t *client = (ds_client_t *) arg;
+	ds_window_t *wnd;
+
+	ds_display_lock(client->display);
+
+	wnd = ds_client_find_window(client, wnd_id);
+	if (wnd == NULL) {
+		ds_display_unlock(client->display);
+		return ENOENT;
+	}
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "disp_window_get_max_rect()");
+	ds_window_get_max_rect(wnd, rect);
+	ds_display_unlock(client->display);
+	return EOK;
+}
+
 static errno_t disp_window_resize_req(void *arg, sysarg_t wnd_id,
-    display_wnd_rsztype_t rsztype, gfx_coord2_t *pos)
+    display_wnd_rsztype_t rsztype, gfx_coord2_t *pos, sysarg_t pos_id)
 {
 	ds_client_t *client = (ds_client_t *) arg;
@@ -193,5 +224,5 @@
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "disp_window_resize_req()");
-	ds_window_resize_req(wnd, rsztype, pos);
+	ds_window_resize_req(wnd, rsztype, pos, pos_id);
 	ds_display_unlock(client->display);
 	return EOK;
@@ -219,4 +250,64 @@
 }
 
+static errno_t disp_window_minimize(void *arg, sysarg_t wnd_id)
+{
+	ds_client_t *client = (ds_client_t *) arg;
+	ds_window_t *wnd;
+	errno_t rc;
+
+	ds_display_lock(client->display);
+
+	wnd = ds_client_find_window(client, wnd_id);
+	if (wnd == NULL) {
+		ds_display_unlock(client->display);
+		return ENOENT;
+	}
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "disp_window_maximize()");
+	rc = ds_window_minimize(wnd);
+	ds_display_unlock(client->display);
+	return rc;
+}
+
+static errno_t disp_window_maximize(void *arg, sysarg_t wnd_id)
+{
+	ds_client_t *client = (ds_client_t *) arg;
+	ds_window_t *wnd;
+	errno_t rc;
+
+	ds_display_lock(client->display);
+
+	wnd = ds_client_find_window(client, wnd_id);
+	if (wnd == NULL) {
+		ds_display_unlock(client->display);
+		return ENOENT;
+	}
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "disp_window_maximize()");
+	rc = ds_window_maximize(wnd);
+	ds_display_unlock(client->display);
+	return rc;
+}
+
+static errno_t disp_window_unmaximize(void *arg, sysarg_t wnd_id)
+{
+	ds_client_t *client = (ds_client_t *) arg;
+	ds_window_t *wnd;
+	errno_t rc;
+
+	ds_display_lock(client->display);
+
+	wnd = ds_client_find_window(client, wnd_id);
+	if (wnd == NULL) {
+		ds_display_unlock(client->display);
+		return ENOENT;
+	}
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "disp_window_unmaximize()");
+	rc = ds_window_unmaximize(wnd);
+	ds_display_unlock(client->display);
+	return rc;
+}
+
 static errno_t disp_window_set_cursor(void *arg, sysarg_t wnd_id,
     display_stock_cursor_t cursor)
@@ -240,4 +331,25 @@
 }
 
+static errno_t disp_window_set_caption(void *arg, sysarg_t wnd_id,
+    const char *caption)
+{
+	ds_client_t *client = (ds_client_t *) arg;
+	ds_window_t *wnd;
+	errno_t rc;
+
+	ds_display_lock(client->display);
+
+	wnd = ds_client_find_window(client, wnd_id);
+	if (wnd == NULL) {
+		ds_display_unlock(client->display);
+		return ENOENT;
+	}
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "disp_window_set_caption()");
+	rc = ds_window_set_caption(wnd, caption);
+	ds_display_unlock(client->display);
+	return rc;
+}
+
 static errno_t disp_get_event(void *arg, sysarg_t *wnd_id,
     display_wnd_ev_t *event)
@@ -247,5 +359,5 @@
 	errno_t rc;
 
-	log_msg(LOG_DEFAULT, LVL_DEBUG, "disp_window_get_event()");
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "disp_window_get_event()");
 
 	ds_display_lock(client->display);
Index: uspace/srv/hid/display/idevcfg.c
===================================================================
--- uspace/srv/hid/display/idevcfg.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/srv/hid/display/idevcfg.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,83 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup display
+ * @{
+ */
+/**
+ * @file Display server input device configuration
+ */
+
+#include <adt/list.h>
+#include <errno.h>
+#include <io/log.h>
+#include <loc.h>
+#include <stdlib.h>
+#include "display.h"
+#include "idevcfg.h"
+#include "seat.h"
+
+/** Create input device configuration entry.
+ *
+ * @param display Parent display
+ * @param svc_id Device service ID
+ * @param seat Seat to which device is assigned
+ * @param ridevcfg Place to store pointer to new input device configuration
+ *                 entry
+ * @return EOK on success, ENOMEM if out of memory
+ */
+errno_t ds_idevcfg_create(ds_display_t *display, service_id_t svc_id,
+    ds_seat_t *seat, ds_idevcfg_t **ridevcfg)
+{
+	ds_idevcfg_t *idevcfg;
+
+	idevcfg = calloc(1, sizeof(ds_idevcfg_t));
+	if (idevcfg == NULL)
+		return ENOMEM;
+
+	idevcfg->svc_id = svc_id;
+	ds_seat_add_idevcfg(seat, idevcfg);
+
+	ds_display_add_idevcfg(display, idevcfg);
+	*ridevcfg = idevcfg;
+	return EOK;
+}
+
+/** Destroy input device configuration entry.
+ *
+ * @param ddev Display device
+ */
+void ds_idevcfg_destroy(ds_idevcfg_t *idevcfg)
+{
+	ds_display_remove_idevcfg(idevcfg);
+	ds_seat_remove_idevcfg(idevcfg);
+	free(idevcfg);
+}
+
+/** @}
+ */
Index: uspace/srv/hid/display/idevcfg.h
===================================================================
--- uspace/srv/hid/display/idevcfg.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/srv/hid/display/idevcfg.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,52 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup display
+ * @{
+ */
+/**
+ * @file Display server input device configuration
+ */
+
+#ifndef IDEVCFG_H
+#define IDEVCFG_H
+
+#include <errno.h>
+#include <loc.h>
+#include "types/display/display.h"
+#include "types/display/idevcfg.h"
+#include "types/display/seat.h"
+
+extern errno_t ds_idevcfg_create(ds_display_t *, service_id_t, ds_seat_t *,
+    ds_idevcfg_t **);
+extern void ds_idevcfg_destroy(ds_idevcfg_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/srv/hid/display/input.c
===================================================================
--- uspace/srv/hid/display/input.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/display/input.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2019 Jiri Svoboda
+ * Copyright (c) 2022 Jiri Svoboda
  * All rights reserved.
  *
@@ -45,8 +45,11 @@
 static errno_t ds_input_ev_active(input_t *);
 static errno_t ds_input_ev_deactive(input_t *);
-static errno_t ds_input_ev_key(input_t *, kbd_event_type_t, keycode_t, keymod_t, char32_t);
-static errno_t ds_input_ev_move(input_t *, int, int);
-static errno_t ds_input_ev_abs_move(input_t *, unsigned, unsigned, unsigned, unsigned);
-static errno_t ds_input_ev_button(input_t *, int, int);
+static errno_t ds_input_ev_key(input_t *, unsigned, kbd_event_type_t, keycode_t,
+    keymod_t, char32_t);
+static errno_t ds_input_ev_move(input_t *, unsigned, int, int);
+static errno_t ds_input_ev_abs_move(input_t *, unsigned, unsigned, unsigned,
+    unsigned, unsigned);
+static errno_t ds_input_ev_button(input_t *, unsigned, int, int);
+static errno_t ds_input_ev_dclick(input_t *, unsigned, int);
 
 static input_ev_ops_t ds_input_ev_ops = {
@@ -56,5 +59,6 @@
 	.move = ds_input_ev_move,
 	.abs_move = ds_input_ev_abs_move,
-	.button = ds_input_ev_button
+	.button = ds_input_ev_button,
+	.dclick = ds_input_ev_dclick
 };
 
@@ -69,6 +73,6 @@
 }
 
-static errno_t ds_input_ev_key(input_t *input, kbd_event_type_t type,
-    keycode_t key, keymod_t mods, char32_t c)
+static errno_t ds_input_ev_key(input_t *input, unsigned kbd_id,
+    kbd_event_type_t type, keycode_t key, keymod_t mods, char32_t c)
 {
 	ds_display_t *disp = (ds_display_t *) input->user;
@@ -76,4 +80,5 @@
 	errno_t rc;
 
+	event.kbd_id = kbd_id;
 	event.type = type;
 	event.key = key;
@@ -87,10 +92,11 @@
 }
 
-static errno_t ds_input_ev_move(input_t *input, int dx, int dy)
-{
-	ds_display_t *disp = (ds_display_t *) input->user;
-	ptd_event_t event;
-	errno_t rc;
-
+static errno_t ds_input_ev_move(input_t *input, unsigned pos_id, int dx, int dy)
+{
+	ds_display_t *disp = (ds_display_t *) input->user;
+	ptd_event_t event;
+	errno_t rc;
+
+	event.pos_id = pos_id;
 	event.type = PTD_MOVE;
 	event.dmove.x = dx;
@@ -103,11 +109,12 @@
 }
 
-static errno_t ds_input_ev_abs_move(input_t *input, unsigned x, unsigned y,
-    unsigned max_x, unsigned max_y)
-{
-	ds_display_t *disp = (ds_display_t *) input->user;
-	ptd_event_t event;
-	errno_t rc;
-
+static errno_t ds_input_ev_abs_move(input_t *input, unsigned pos_id, unsigned x,
+    unsigned y, unsigned max_x, unsigned max_y)
+{
+	ds_display_t *disp = (ds_display_t *) input->user;
+	ptd_event_t event;
+	errno_t rc;
+
+	event.pos_id = pos_id;
 	event.type = PTD_ABS_MOVE;
 	event.apos.x = x;
@@ -124,11 +131,31 @@
 }
 
-static errno_t ds_input_ev_button(input_t *input, int bnum, int bpress)
-{
-	ds_display_t *disp = (ds_display_t *) input->user;
-	ptd_event_t event;
-	errno_t rc;
-
+static errno_t ds_input_ev_button(input_t *input, unsigned pos_id, int bnum,
+    int bpress)
+{
+	ds_display_t *disp = (ds_display_t *) input->user;
+	ptd_event_t event;
+	errno_t rc;
+
+	event.pos_id = pos_id;
 	event.type = bpress ? PTD_PRESS : PTD_RELEASE;
+	event.btn_num = bnum;
+	event.dmove.x = 0;
+	event.dmove.y = 0;
+
+	ds_display_lock(disp);
+	rc = ds_display_post_ptd_event(disp, &event);
+	ds_display_unlock(disp);
+	return rc;
+}
+
+static errno_t ds_input_ev_dclick(input_t *input, unsigned pos_id, int bnum)
+{
+	ds_display_t *disp = (ds_display_t *) input->user;
+	ptd_event_t event;
+	errno_t rc;
+
+	event.pos_id = pos_id;
+	event.type = PTD_DCLICK;
 	event.btn_num = bnum;
 	event.dmove.x = 0;
Index: uspace/srv/hid/display/main.c
===================================================================
--- uspace/srv/hid/display/main.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/display/main.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2019 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -36,4 +36,5 @@
 #include <async.h>
 #include <disp_srv.h>
+#include <dispcfg_srv.h>
 #include <errno.h>
 #include <gfx/context.h>
@@ -47,4 +48,7 @@
 #include <stdio.h>
 #include <task.h>
+#include <wndmgt_srv.h>
+#include "cfgclient.h"
+#include "cfgops.h"
 #include "client.h"
 #include "display.h"
@@ -55,7 +59,14 @@
 #include "seat.h"
 #include "window.h"
+#include "wmclient.h"
+#include "wmops.h"
 
 static void display_client_conn(ipc_call_t *, void *);
 static void display_client_ev_pending(void *);
+static void display_wmclient_ev_pending(void *);
+static void display_cfgclient_ev_pending(void *);
+static void display_gc_conn(ipc_call_t *, void *);
+static void display_wndmgt_conn(ipc_call_t *, void *);
+static void display_dispcfg_conn(ipc_call_t *, void *);
 
 #ifdef CONFIG_DISP_DOUBLE_BUF
@@ -76,4 +87,12 @@
 };
 
+static ds_wmclient_cb_t display_wmclient_cb = {
+	.ev_pending = display_wmclient_ev_pending
+};
+
+static ds_cfgclient_cb_t display_cfgclient_cb = {
+	.ev_pending = display_cfgclient_ev_pending
+};
+
 static void display_client_ev_pending(void *arg)
 {
@@ -81,4 +100,18 @@
 
 	display_srv_ev_pending(srv);
+}
+
+static void display_wmclient_ev_pending(void *arg)
+{
+	wndmgt_srv_t *srv = (wndmgt_srv_t *) arg;
+
+	wndmgt_srv_ev_pending(srv);
+}
+
+static void display_cfgclient_ev_pending(void *arg)
+{
+	dispcfg_srv_t *srv = (dispcfg_srv_t *) arg;
+
+	dispcfg_srv_ev_pending(srv);
 }
 
@@ -90,4 +123,10 @@
 	ds_output_t *output = NULL;
 	gfx_context_t *gc = NULL;
+	port_id_t disp_port;
+	port_id_t gc_port;
+	port_id_t wm_port;
+	port_id_t dc_port;
+	loc_srv_t *srv = NULL;
+	service_id_t sid = 0;
 	errno_t rc;
 
@@ -98,5 +137,5 @@
 		goto error;
 
-	rc = ds_seat_create(disp, &seat);
+	rc = ds_seat_create(disp, "Alice", &seat);
 	if (rc != EOK)
 		goto error;
@@ -115,7 +154,24 @@
 		goto error;
 
-	async_set_fallback_port_handler(display_client_conn, disp);
-
-	rc = loc_server_register(NAME);
+	rc = async_create_port(INTERFACE_DISPLAY, display_client_conn, disp,
+	    &disp_port);
+	if (rc != EOK)
+		goto error;
+
+	rc = async_create_port(INTERFACE_GC, display_gc_conn, disp, &gc_port);
+	if (rc != EOK)
+		goto error;
+
+	rc = async_create_port(INTERFACE_WNDMGT, display_wndmgt_conn, disp,
+	    &wm_port);
+	if (rc != EOK)
+		goto error;
+
+	rc = async_create_port(INTERFACE_DISPCFG, display_dispcfg_conn, disp,
+	    &dc_port);
+	if (rc != EOK)
+		goto error;
+
+	rc = loc_server_register(NAME, &srv);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server: %s.", str_error(rc));
@@ -124,6 +180,5 @@
 	}
 
-	service_id_t sid;
-	rc = loc_service_register(SERVICE_NAME_DISPLAY, &sid);
+	rc = loc_service_register(srv, SERVICE_NAME_DISPLAY, &sid);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service: %s.", str_error(rc));
@@ -135,4 +190,12 @@
 	return EOK;
 error:
+	if (sid != 0)
+		loc_service_unregister(srv, sid);
+	if (srv != NULL)
+		loc_server_unregister(srv);
+	// XXX destroy disp_port
+	// XXX destroy gc_port
+	// XXX destroy wm_port
+	// XXX destroy dc_port
 #if 0
 	if (disp->input != NULL)
@@ -154,10 +217,7 @@
 {
 	display_srv_t srv;
-	sysarg_t wnd_id;
 	sysarg_t svc_id;
 	ds_client_t *client = NULL;
-	ds_window_t *wnd;
 	ds_display_t *disp = (ds_display_t *) arg;
-	gfx_context_t *gc;
 	errno_t rc;
 
@@ -166,13 +226,11 @@
 	    ipc_get_arg4(icall));
 
-	(void) icall;
-	(void) arg;
-
 	svc_id = ipc_get_arg2(icall);
-	wnd_id = ipc_get_arg3(icall);
 
 	if (svc_id != 0) {
 		/* Create client object */
+		ds_display_lock(disp);
 		rc = ds_client_create(disp, &display_client_cb, &srv, &client);
+		ds_display_unlock(disp);
 		if (rc != EOK) {
 			async_answer_0(icall, ENOMEM);
@@ -191,20 +249,95 @@
 		ds_client_destroy(client);
 		ds_display_unlock(disp);
-	} else {
-		/* Window GC connection */
-
-		wnd = ds_display_find_window(disp, wnd_id);
-		if (wnd == NULL) {
-			async_answer_0(icall, ENOENT);
-			return;
-		}
-
-		/*
-		 * XXX We need a way to make sure that the connection does
-		 * not stay active after the window had been destroyed
-		 */
-		gc = ds_window_get_ctx(wnd);
-		gc_conn(icall, gc);
-	}
+	}
+}
+
+/** Handle GC connection to display server */
+static void display_gc_conn(ipc_call_t *icall, void *arg)
+{
+	sysarg_t wnd_id;
+	ds_window_t *wnd;
+	ds_display_t *disp = (ds_display_t *) arg;
+	gfx_context_t *gc;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "display_gc_conn arg1=%zu arg2=%zu arg3=%zu arg4=%zu.",
+	    ipc_get_arg1(icall), ipc_get_arg2(icall), ipc_get_arg3(icall),
+	    ipc_get_arg4(icall));
+
+	wnd_id = ipc_get_arg3(icall);
+
+	/* Window GC connection */
+
+	wnd = ds_display_find_window(disp, wnd_id);
+	if (wnd == NULL) {
+		async_answer_0(icall, ENOENT);
+		return;
+	}
+
+	/*
+	 * XXX We need a way to make sure that the connection does
+	 * not stay active after the window had been destroyed
+	 */
+	gc = ds_window_get_ctx(wnd);
+	gc_conn(icall, gc);
+}
+
+/** Handle window management connection to display server */
+static void display_wndmgt_conn(ipc_call_t *icall, void *arg)
+{
+	ds_display_t *disp = (ds_display_t *) arg;
+	errno_t rc;
+	wndmgt_srv_t srv;
+	ds_wmclient_t *wmclient = NULL;
+
+	/* Create WM client object */
+	ds_display_lock(disp);
+	rc = ds_wmclient_create(disp, &display_wmclient_cb, &srv, &wmclient);
+	ds_display_unlock(disp);
+	if (rc != EOK) {
+		async_answer_0(icall, ENOMEM);
+		return;
+	}
+
+	/* Set up protocol structure */
+	wndmgt_srv_initialize(&srv);
+	srv.ops = &wndmgt_srv_ops;
+	srv.arg = wmclient;
+
+	/* Handle connection */
+	wndmgt_conn(icall, &srv);
+
+	ds_display_lock(disp);
+	ds_wmclient_destroy(wmclient);
+	ds_display_unlock(disp);
+}
+
+/** Handle configuration connection to display server */
+static void display_dispcfg_conn(ipc_call_t *icall, void *arg)
+{
+	ds_display_t *disp = (ds_display_t *) arg;
+	errno_t rc;
+	dispcfg_srv_t srv;
+	ds_cfgclient_t *cfgclient = NULL;
+
+	/* Create CFG client object */
+	ds_display_lock(disp);
+	rc = ds_cfgclient_create(disp, &display_cfgclient_cb, &srv, &cfgclient);
+	ds_display_unlock(disp);
+	if (rc != EOK) {
+		async_answer_0(icall, ENOMEM);
+		return;
+	}
+
+	/* Set up protocol structure */
+	dispcfg_srv_initialize(&srv);
+	srv.ops = &dispcfg_srv_ops;
+	srv.arg = cfgclient;
+
+	/* Handle connection */
+	dispcfg_conn(icall, &srv);
+
+	ds_display_lock(disp);
+	ds_cfgclient_destroy(cfgclient);
+	ds_display_unlock(disp);
 }
 
Index: uspace/srv/hid/display/meson.build
===================================================================
--- uspace/srv/hid/display/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/display/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2019 Jiri Svoboda
+# Copyright (c) 2023 Jiri Svoboda
 # All rights reserved.
 #
@@ -27,7 +27,9 @@
 #
 
-deps = [ 'ipcgfx', 'memgfx', 'display', 'ddev' ]
+deps = [ 'ipcgfx', 'memgfx', 'display', 'ddev', 'dispcfg', 'wndmgt', 'input' ]
 
 src = files(
+	'cfgclient.c',
+	'cfgops.c',
 	'client.c',
 	'clonegc.c',
@@ -37,4 +39,5 @@
 	'display.c',
 	'dsops.c',
+	'idevcfg.c',
 	'input.c',
 	'main.c',
@@ -42,7 +45,10 @@
 	'seat.c',
 	'window.c',
+	'wmclient.c',
+	'wmops.c',
 )
 
 test_src = files(
+	'cfgclient.c',
 	'client.c',
 	'clonegc.c',
@@ -51,6 +57,9 @@
 	'ddev.c',
 	'display.c',
+	'idevcfg.c',
 	'seat.c',
 	'window.c',
+	'wmclient.c',
+	'test/cfgclient.c',
 	'test/client.c',
 	'test/clonegc.c',
@@ -60,3 +69,4 @@
 	'test/seat.c',
 	'test/window.c',
+	'test/wmclient.c',
 )
Index: uspace/srv/hid/display/seat.c
===================================================================
--- uspace/srv/hid/display/seat.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/display/seat.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -39,7 +39,9 @@
 #include <gfx/render.h>
 #include <stdlib.h>
+#include <str.h>
 #include "client.h"
 #include "cursor.h"
 #include "display.h"
+#include "idevcfg.h"
 #include "seat.h"
 #include "window.h"
@@ -51,10 +53,20 @@
  *
  * @param display Parent display
+ * @param name Seat name
  * @param rseat Place to store pointer to new seat.
  * @return EOK on success, ENOMEM if out of memory
  */
-errno_t ds_seat_create(ds_display_t *display, ds_seat_t **rseat)
+errno_t ds_seat_create(ds_display_t *display, const char *name,
+    ds_seat_t **rseat)
 {
 	ds_seat_t *seat;
+	ds_seat_t *s0;
+
+	s0 = ds_display_first_seat(display);
+	while (s0 != NULL) {
+		if (str_cmp(s0->name, name) == 0)
+			return EEXIST;
+		s0 = ds_display_next_seat(s0);
+	}
 
 	seat = calloc(1, sizeof(ds_seat_t));
@@ -62,4 +74,12 @@
 		return ENOMEM;
 
+	seat->name = str_dup(name);
+	if (seat->name == NULL) {
+		free(seat);
+		return ENOMEM;
+	}
+
+	list_initialize(&seat->idevcfgs);
+
 	ds_display_add_seat(display, seat);
 	seat->pntpos.x = 0;
@@ -68,4 +88,5 @@
 	seat->client_cursor = display->cursor[dcurs_arrow];
 	seat->wm_cursor = NULL;
+	seat->focus = ds_display_first_window(display);
 
 	*rseat = seat;
@@ -79,5 +100,20 @@
 void ds_seat_destroy(ds_seat_t *seat)
 {
+	ds_idevcfg_t *idevcfg;
+
+	/* Remove all input device configuration entries pointing to this seat */
+	idevcfg = ds_seat_first_idevcfg(seat);
+	while (idevcfg != NULL) {
+		ds_idevcfg_destroy(idevcfg);
+		idevcfg = ds_seat_first_idevcfg(seat);
+	}
+
+	/* Remove this seat's focus */
+	if (seat->focus != NULL)
+		ds_window_post_unfocus_event(seat->focus);
+
 	ds_display_remove_seat(seat);
+
+	free(seat->name);
 	free(seat);
 }
@@ -90,7 +126,15 @@
 void ds_seat_set_focus(ds_seat_t *seat, ds_window_t *wnd)
 {
+	errno_t rc;
+
 	if (wnd == seat->focus) {
 		/* Focus is not changing */
 		return;
+	}
+
+	if (wnd != NULL) {
+		rc = ds_window_unminimize(wnd);
+		if (rc != EOK)
+			return;
 	}
 
@@ -130,23 +174,14 @@
 /** Evacuate seat references to window.
  *
- * If seat's focus is @a wnd, it will be set to a different window.
+ * If seat's focus is @a wnd, it will be set to NULL.
  * If seat's popup window is @a wnd, it will be set to NULL.
  *
  * @param seat Seat
- * @param wnd Window to evacuate focus from
+ * @param wnd Window to evacuate references from
  */
 void ds_seat_evac_wnd_refs(ds_seat_t *seat, ds_window_t *wnd)
 {
-	ds_window_t *nwnd;
-
-	if (seat->focus == wnd) {
-		nwnd = ds_display_prev_window(wnd);
-		if (nwnd == NULL)
-			nwnd = ds_display_last_window(wnd->display);
-		if (nwnd == wnd)
-			nwnd = NULL;
-
-		ds_seat_set_focus(seat, nwnd);
-	}
+	if (seat->focus == wnd)
+		ds_seat_set_focus(seat, NULL);
 
 	if (seat->popup == wnd)
@@ -154,4 +189,30 @@
 }
 
+/** Unfocus window.
+ *
+ * If seat's focus is @a wnd, it will be set to a different window
+ * that is not minimized, preferably not a system window.
+ *
+ * @param seat Seat
+ * @param wnd Window to remove focus from
+ */
+void ds_seat_unfocus_wnd(ds_seat_t *seat, ds_window_t *wnd)
+{
+	ds_window_t *nwnd;
+
+	if (seat->focus != wnd)
+		return;
+
+	/* Find alternate window that is neither system nor minimized */
+	nwnd = ds_window_find_prev(wnd, ~(wndf_minimized | wndf_system));
+
+	if (nwnd == NULL) {
+		/* Find alternate window that is not minimized */
+		nwnd = ds_window_find_prev(wnd, ~wndf_minimized);
+	}
+
+	ds_seat_set_focus(seat, nwnd);
+}
+
 /** Switch focus to another window.
  *
@@ -163,12 +224,13 @@
 	ds_window_t *nwnd;
 
-	if (seat->focus != NULL)
-		nwnd = ds_display_prev_window(seat->focus);
-	else
-		nwnd = NULL;
-
-	if (nwnd == NULL)
-		nwnd = ds_display_last_window(seat->display);
-
+	if (seat->focus != NULL) {
+		/* Find alternate window that is not a system window */
+		nwnd = ds_window_find_next(seat->focus, ~wndf_system);
+	} else {
+		/* Currently no focus. Focus topmost window. */
+		nwnd = ds_display_first_window(seat->display);
+	}
+
+	/* Only switch focus if there is another window */
 	if (nwnd != NULL)
 		ds_seat_set_focus(seat, nwnd);
@@ -362,8 +424,21 @@
 	}
 
-	if (event->type == PTD_PRESS || event->type == PTD_RELEASE) {
-		pevent.pos_id = 0;
-		pevent.type = (event->type == PTD_PRESS) ?
-		    POS_PRESS : POS_RELEASE;
+	if (event->type == PTD_PRESS || event->type == PTD_RELEASE ||
+	    event->type == PTD_DCLICK) {
+		pevent.pos_id = event->pos_id;
+		switch (event->type) {
+		case PTD_PRESS:
+			pevent.type = POS_PRESS;
+			break;
+		case PTD_RELEASE:
+			pevent.type = POS_RELEASE;
+			break;
+		case PTD_DCLICK:
+			pevent.type = POS_DCLICK;
+			break;
+		default:
+			assert(false);
+		}
+
 		pevent.btn_num = event->btn_num;
 		pevent.hpos = seat->pntpos.x;
@@ -382,5 +457,5 @@
 		seat->pntpos = npos;
 
-		pevent.pos_id = 0;
+		pevent.pos_id = event->pos_id;
 		pevent.type = POS_UPDATE;
 		pevent.btn_num = 0;
@@ -410,5 +485,5 @@
 		seat->pntpos = npos;
 
-		pevent.pos_id = 0;
+		pevent.pos_id = event->pos_id;
 		pevent.type = POS_UPDATE;
 		pevent.btn_num = 0;
@@ -440,12 +515,6 @@
 	wnd = ds_display_window_by_pos(seat->display, &seat->pntpos);
 
-	/* Click outside popup window */
-	if (event->type == POS_PRESS && wnd != seat->popup) {
-		/* Close popup window */
-		ds_seat_set_popup(seat, NULL);
-	}
-
 	/* Deliver event to popup window. */
-	if (seat->popup != NULL) {
+	if (seat->popup != NULL && event->type != POS_PRESS) {
 		rc = ds_window_post_pos_event(seat->popup, event);
 		if (rc != EOK)
@@ -471,5 +540,5 @@
 		 * to the same window above.
 		 */
-		if (wnd != seat->popup) {
+		if (wnd != seat->popup || event->type == POS_PRESS) {
 			rc = ds_window_post_pos_event(wnd, event);
 			if (rc != EOK)
@@ -481,4 +550,10 @@
 	}
 
+	/* Click outside popup window */
+	if (event->type == POS_PRESS && wnd != seat->popup) {
+		/* Close popup window */
+		ds_seat_set_popup(seat, NULL);
+	}
+
 	return EOK;
 }
@@ -497,4 +572,58 @@
 }
 
+/** Add input device configuration entry to seat.
+ *
+ * @param seat Seat
+ * @param idevcfg Input device configuration
+ */
+void ds_seat_add_idevcfg(ds_seat_t *seat, ds_idevcfg_t *idevcfg)
+{
+	assert(idevcfg->seat == NULL);
+	assert(!link_used(&idevcfg->lseatidcfgs));
+
+	idevcfg->seat = seat;
+	list_append(&idevcfg->lseatidcfgs, &seat->idevcfgs);
+}
+
+/** Remove input device configuration entry from seat.
+ *
+ * @param idevcfg Input device configuration entry
+ */
+void ds_seat_remove_idevcfg(ds_idevcfg_t *idevcfg)
+{
+	list_remove(&idevcfg->lseatidcfgs);
+	idevcfg->seat = NULL;
+}
+
+/** Get first input device configuration entry in seat.
+ *
+ * @param disp Display
+ * @return First input device configuration entry or @c NULL if there is none
+ */
+ds_idevcfg_t *ds_seat_first_idevcfg(ds_seat_t *seat)
+{
+	link_t *link = list_first(&seat->idevcfgs);
+
+	if (link == NULL)
+		return NULL;
+
+	return list_get_instance(link, ds_idevcfg_t, lseatidcfgs);
+}
+
+/** Get next input device configuration entry in seat.
+ *
+ * @param idevcfg Current input device configuration entry
+ * @return Next input device configuration entry or @c NULL if there is none
+ */
+ds_idevcfg_t *ds_seat_next_idevcfg(ds_idevcfg_t *idevcfg)
+{
+	link_t *link = list_next(&idevcfg->lseatidcfgs, &idevcfg->seat->idevcfgs);
+
+	if (link == NULL)
+		return NULL;
+
+	return list_get_instance(link, ds_idevcfg_t, lseatidcfgs);
+}
+
 /** @}
  */
Index: uspace/srv/hid/display/seat.h
===================================================================
--- uspace/srv/hid/display/seat.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/display/seat.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -46,9 +46,10 @@
 #include "types/display/window.h"
 
-extern errno_t ds_seat_create(ds_display_t *, ds_seat_t **);
+extern errno_t ds_seat_create(ds_display_t *, const char *, ds_seat_t **);
 extern void ds_seat_destroy(ds_seat_t *);
 extern void ds_seat_set_focus(ds_seat_t *, ds_window_t *);
 extern void ds_seat_set_popup(ds_seat_t *, ds_window_t *);
 extern void ds_seat_evac_wnd_refs(ds_seat_t *, ds_window_t *);
+extern void ds_seat_unfocus_wnd(ds_seat_t *, ds_window_t *);
 extern void ds_seat_switch_focus(ds_seat_t *);
 extern errno_t ds_seat_post_kbd_event(ds_seat_t *, kbd_event_t *);
@@ -57,4 +58,8 @@
 extern void ds_seat_set_wm_cursor(ds_seat_t *, ds_cursor_t *);
 extern errno_t ds_seat_paint_pointer(ds_seat_t *, gfx_rect_t *);
+extern void ds_seat_add_idevcfg(ds_seat_t *, ds_idevcfg_t *);
+extern void ds_seat_remove_idevcfg(ds_idevcfg_t *);
+extern ds_idevcfg_t *ds_seat_first_idevcfg(ds_seat_t *);
+extern ds_idevcfg_t *ds_seat_next_idevcfg(ds_idevcfg_t *);
 
 #endif
